"use strict";

exports.run = run;

var _child_process = require('child_process');

var child_process = _child_process;

/**
 * Run a shell command
 * @param  {string} cmd
 * @return {Promise<stdout, stderr>} Promise with standard output and error results
 */

function run(cmd) {
    return new Promise(function (res, rej) {
        child_process.exec(cmd, function (error, stdout, stderr) {
            if (error !== null) {
                rej(error);
            } else {
                res(stdout, stderr);
            }
        });
    });
}