'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _request = require('request');

var request = _request;

var _base = require('./base');

var CheckGithub = (function (_StepBase) {
    _inherits(CheckGithub, _StepBase);

    /**
     * Public constructor
     *
     * Here the step should register any commandline options it needs with
     * commander.
     * @param  {Commander} globals
     */

    function CheckGithub(globals) {
        _classCallCheck(this, CheckGithub);

        _get(Object.getPrototypeOf(CheckGithub.prototype), 'constructor', this).call(this, globals);
        globals.option('-r, --reinstall', 'reinstall existing repositories, without recloning');
    }

    /**
     * Gets the name of the section
     * @return {string}
     */

    _createClass(CheckGithub, [{
        key: 'shouldRun',

        /**
         * Checks if the step should run
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|boolean} should run
         */
        value: function shouldRun() {
            return !this.globals.reinstall;
        }

        /**
         * Run the step
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|object} results
         */
    }, {
        key: 'run',
        value: function run(previousStepResults) {
            var _this = this;

            return Promise.all(this.globals.repos.map(function (x, i) {
                return _this.findRepo(_this.globals.githubName, x, _this.globals.orgRepos[i]);

                // Pass along the results from the previous step.
            })).then(function () {
                return previousStepResults;
            });
        }

        /**
         * Check to see if a repository exists.
         * @param  {string} org
         * @param  {string} repo
         * @param  {string} original - orgRepo string for which the repository 
         *                           should be forked from, used for logging.
         * @return {Promise}
         */
    }, {
        key: 'findRepo',
        value: function findRepo(org, repo, original) {
            var _this2 = this;

            var orgRepo = org + '/' + repo;
            return new Promise(function (resolve, reject) {
                request('http://github.com/' + orgRepo, function (error, response, body) {
                    if (!error && response.statusCode == 200) {
                        resolve(body);
                        _this2.success(orgRepo + ' on GitHub');
                    } else {
                        _this2.failure(orgRepo + ' on GitHub');
                        _this2.details('Use github.com to fork ' + original + ' to ' + orgRepo);
                        reject(error || response.statusCode);
                    }
                });
            });
        }
    }, {
        key: 'section',
        get: function get() {
            return "Checking github repositories";
        }
    }]);

    return CheckGithub;
})(_base.StepBase);

exports['default'] = CheckGithub;