'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _testRun = require('../test-run');

var _base = require('./base');

var CheckSystem = (function (_StepBase) {
    _inherits(CheckSystem, _StepBase);

    function CheckSystem() {
        _classCallCheck(this, CheckSystem);

        _get(Object.getPrototypeOf(CheckSystem.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(CheckSystem, [{
        key: 'run',

        /**
         * Run the step
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|object} results
         */
        value: function run(previousStepResults) {
            var tests = [(0, _testRun.testRun)('git --version'), (0, _testRun.testRun)('node --version'), (0, _testRun.testRun)('npm --version')];

            if (!this.globals.skipPip) {
                tests = tests.concat([(0, _testRun.testRun)('python --version'), (0, _testRun.testRun)('python -m pip --version', 'pip'), (0, _testRun.testRun)('python -c "import zmq"', 'pyzmq', '`pyzmq` not installed for `python`.  Please install pyzmq for python.\n        Before installing pyzmq, you may need to install python and zmq dev packages (`python-dev` and `libzmq3-dev` on debian based distros).'), (0, _testRun.testRun)('python -c "import pycurl"', 'pycurl', '`pycurl` not installed for `python`.  Please install pycurl for python.\n        Before installing pycurl, you may need `libcurl4-openssl-dev` and `libssl-dev` on debian based distros or `libcurl-devel` and `openssl-devel` on slackware based distros.\n        For Windows machines, try the appropriate binary found here http://www.lfd.uci.edu/~gohlke/pythonlibs/#pycurl . You\'ll need to use pip to install it.')]);
            }

            if (!this.globals.skipNpm) {
                // It would be normal to expect the the node and npm checks here,
                // unfortunately that's not the case.  Some of the Jupyter PIP
                // projects actually piggy back NPM so we still need to check for it.
            }

            return Promise.all(tests);
        }
    }, {
        key: 'section',

        /**
         * Gets the name of the section
         * @return {string}
         */
        get: function get() {
            return "Checking system requirements";
        }
    }]);

    return CheckSystem;
})(_base.StepBase);

exports['default'] = CheckSystem;