'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _base = require('./base');

var _path = require('path');

var path = _path;

var _run2 = require('../run');

var _chalk = require('chalk');

var chalk = _chalk;

var Clone = (function (_StepBase) {
    _inherits(Clone, _StepBase);

    function Clone() {
        _classCallCheck(this, Clone);

        _get(Object.getPrototypeOf(Clone.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(Clone, [{
        key: 'shouldRun',

        /**
         * Checks if the step should run
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|boolean} should run
         */
        value: function shouldRun() {
            return !this.globals.reinstall;
        }

        /**
         * Run the step
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|object} results
         */
    }, {
        key: 'run',
        value: function run(previousStepResults) {
            var _this = this;

            var errored = undefined;
            return Promise.all(this.globals.orgRepos.map(function (orgRepo, i) {
                var url = undefined;
                // url = 'git@github.com:' + githubName + '/' + repos[i] + '.git';
                url = 'https://github.com/' + _this.globals.githubName + '/' + _this.globals.repos[i] + '.git';

                var dir = path.resolve(_this.globals.installdir, orgRepo);
                return (0, _run2.run)('git clone ' + url + ' ' + dir).then(function () {
                    _this.success(orgRepo + ' cloned');
                })['catch'](function (err) {
                    _this.failure(orgRepo + ' cloned');
                    _this.details(err);
                    errored = true;
                }).then(function () {
                    return (0, _run2.run)('git -C ' + dir + ' remote add ' + previousStepResults.upstream + ' https://github.com/' + orgRepo + '.git');
                }).then(function () {
                    _this.success(orgRepo + ' ' + previousStepResults.upstream + ' remote added');
                })['catch'](function (err) {
                    _this.failure(orgRepo + ' ' + previousStepResults.upstream + ' remote added');
                    _this.details(err);
                    errored = true;
                }).then(function () {
                    return (0, _run2.run)('git -C ' + dir + ' remote update');
                }).then(function () {
                    _this.success(orgRepo + ' remotes updated');
                })['catch'](function (err) {
                    _this.failure(orgRepo + ' remotes updated');
                    _this.details(err);
                    errored = true;
                }).then(function () {
                    return (0, _run2.run)('git -C ' + dir + ' checkout ' + previousStepResults.upstream + '/master');
                }).then(function () {
                    _this.success(orgRepo + ' master checked out');
                })['catch'](function (err) {
                    _this.failure(orgRepo + ' master checked out');
                    _this.details(err);
                    errored = true;
                });

                // Continue to pass the config on.
            })).then(function () {
                if (errored) {
                    console.log('    ' + chalk.bgCyan.white.bold('One or more errors occured while cloning from GitHub, this is probably because the installer is attempting to overwrite existing contents.  Continuing...'));
                }
                return previousStepResults;
            });
        }
    }, {
        key: 'section',

        /**
         * Gets the name of the section
         * @return {string}
         */
        get: function get() {
            return "Cloning repositories";
        }
    }]);

    return Clone;
})(_base.StepBase);

exports['default'] = Clone;