'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _prompt = require('prompt');

var prompt = _prompt;

var _base = require('./base');

var Config = (function (_StepBase) {
    _inherits(Config, _StepBase);

    /**
     * Public constructor
     *
     * Here the step should register any commandline options it needs with
     * commander.
     * @param  {Commander} globals
     */

    function Config(globals) {
        _classCallCheck(this, Config);

        _get(Object.getPrototypeOf(Config.prototype), 'constructor', this).call(this, globals);
        globals.option('-u, --upstream [string]', 'name of the upstream git remote [upstream]', 'upstream');
        globals.option('-g, --global', 'global install');
        globals.option('-n, --no-install', 'don\'t install');
    }

    /**
     * Gets the name of the section
     * @return {string}
     */

    _createClass(Config, [{
        key: 'run',

        /**
         * Run the step
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|object} results
         */
        value: function run(previousStepResults) {
            var _this = this;

            var properties = {};
            properties.install = {
                description: 'Do you want the Python contents to be installed (l)ocally, (g)lobally, or (n)ot at all?',
                required: false,
                pattern: /[lgn]/,
                message: '(l)ocally, (g)lobally, or (n)ot at all',
                'default': this.globals.noInstall ? 'n' : this.globals.global ? 'g' : 'l'
            };

            // If we aren't reinstalling, ask what the upstream remote should be labeled as.
            if (!this.globals.reinstall) {
                properties.upstream = {
                    description: 'Enter the name you want to use for the git remote that targets upstream',
                    required: false,
                    'default': this.globals.upstream
                };
            }

            // If this is a silent execution, return the defaults.
            if (this.globals.silent) {
                defaults = {};
                Object.keys(properties).forEach(function (property) {
                    defaults[property] = properties[property]['default'];
                });
                return defaults;
            }

            // Prompt
            return new Promise(function (resolve) {
                prompt.start();
                prompt.get({ properties: properties }, function (err, result) {
                    if (err) _this.abort('User abort', 0);
                    resolve(result);
                });
            })['catch'](function (err) {
                _this.abort(['Error while configuring', err], 1);
            });
        }
    }, {
        key: 'section',
        get: function get() {
            // If this is a silent install, don't print the header.
            return this.globals.silent ? "" : "Config";
        }
    }]);

    return Config;
})(_base.StepBase);

exports['default'] = Config;