'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _base = require('./base');

var Filter = (function (_StepBase) {
    _inherits(Filter, _StepBase);

    /**
     * Public constructor
     *
     * Here the step should register any commandline options it needs with
     * commander.
     * @param  {Commander} globals
     */

    function Filter(globals) {
        _classCallCheck(this, Filter);

        _get(Object.getPrototypeOf(Filter.prototype), 'constructor', this).call(this, globals);
        globals.option('-P, --skip-pip', 'skip pip projects');
        globals.option('-N, --skip-npm', 'skip npm projects');
    }

    /**
     * Gets the name of the section
     * @return {string}
     */

    _createClass(Filter, [{
        key: 'run',

        /**
         * Run the step
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|object} results
         */
        value: function run(previousStepResults) {
            var _this = this;

            var disallowedTools = [];
            if (this.globals.skipPip) disallowedTools.push('pip');
            if (this.globals.skipNpm) disallowedTools.push('npm');
            if (disallowedTools.length > 0) {
                this.details('user disabled the following installers ' + String(disallowedTools));
                Object.keys(this.globals.tools).forEach(function (tool) {
                    if (disallowedTools.indexOf(tool) !== -1) {
                        _this.globals.tools[tool].forEach(function (orgRepo) {
                            _this.globals.orgRepos.splice(_this.globals.orgRepos.indexOf(orgRepo), 1);
                        });
                        delete _this.globals.tools[tool];
                    }
                });

                // Reconstruct repos and orgs lists.
                this.globals.repos = this.globals.orgRepos.map(function (x) {
                    return x.split('/')[1];
                });
                this.globals.orgs = this.globals.orgRepos.map(function (x) {
                    return x.split('/')[0];
                }).filter(function (x, i, self) {
                    return self.indexOf(x) === i;
                });
            }
            return previousStepResults;
        }
    }, {
        key: 'section',
        get: function get() {
            return "";
        }
    }]);

    return Filter;
})(_base.StepBase);

exports['default'] = Filter;