'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _base = require('./base');

var _path = require('path');

var path = _path;

var _run2 = require('../run');

var NPM = (function (_StepBase) {
    _inherits(NPM, _StepBase);

    function NPM() {
        _classCallCheck(this, NPM);

        _get(Object.getPrototypeOf(NPM.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(NPM, [{
        key: 'run',

        /**
         * Run the step
         * @param  {object} previousStepResults - results from the previous step
         * @return {Promise|object} results
         */
        value: function run(previousStepResults) {
            var _this = this;

            if (previousStepResults.install === 'l' || previousStepResults.install === 'g') {
                var chain = Promise.resolve();
                if (this.globals.tools.npm) {
                    var _loop = function (i) {
                        var orgRepo = _this.globals.tools.npm[i];
                        var shell = 'npm ln ' + path.resolve(_this.globals.installdir, orgRepo);
                        chain = chain.then(function () {
                            return (0, _run2.run)(shell);
                        }).then(function (stdout) {
                            _this.success(orgRepo + ' installed');
                            _this.details(stdout);
                        })['catch'](function (err) {
                            _this.failure(orgRepo + ' installed');
                            _this.abort(err, 1);
                        });
                    };

                    for (var i = 0; i < this.globals.tools.npm.length; i++) {
                        _loop(i);
                    }
                }

                return chain.then(function () {
                    return previousStepResults;
                });
            }
        }
    }, {
        key: 'section',

        /**
         * Gets the name of the section
         * @return {string}
         */
        get: function get() {
            return "Install Node packages";
        }
    }]);

    return NPM;
})(_base.StepBase);

exports['default'] = NPM;