'use strict';

exports.testRun = testRun;

var _run = require('./run');

var _logging = require('./logging');

function testRun(command, alias, failureDetails) {
    alias = alias || command.split(' ')[0];

    return (0, _run.run)(command).then(function (stdout) {
        (0, _logging.success)(alias + ' is installed');
        if (stdout.trim().length > 0) {
            (0, _logging.details)(stdout);
        }
    })['catch'](function (err) {
        (0, _logging.failure)(alias + ' is installed');
        (0, _logging.details)(failureDetails || alias + ' is not installed, please install ' + alias + '');
        process.exit(1);
    });
}